/// <reference types="node" />
import { RawGtv } from "../gtv/types";
import { QueryArguments, QueryObject } from "../restclient/types";
import { GTX } from "./types";
export interface Itransaction {
    [x: string]: any;
    gtx: GTX;
    sign(signatureProvider: SignatureProvider): Promise<void>;
    sign(privKey: Buffer, pubKey?: Buffer): Promise<void>;
    getTxRID: () => Buffer;
    getDigestToSign: () => Buffer;
    addSignature: (pubKey: Buffer, signature: Buffer) => void;
    addOperation: (name: string, ...args: RawGtv[]) => void;
    postAndWaitConfirmation(): Promise<null>;
    send: (callback: (error: Error, responseObject: any) => void) => void;
    encode: () => Buffer;
}
export interface GtxClient {
    newTransaction: (signers: Buffer[]) => Itransaction;
    transactionFromRawTransaction: (rawTransaction: Buffer) => Itransaction;
    query(object: QueryObject): Promise<any>;
    query(name: string, queryArguments?: QueryArguments): Promise<any>;
}
export interface SignatureProvider {
    sign(gtx: Buffer): Promise<Buffer>;
    readonly pubKey: Buffer;
}
export interface IKeyPair {
    privKey: string | Buffer;
    pubKey?: string | Buffer;
}
